3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
33 # Resolve relative url by appending to parent's url
34 resolve_relative_url ()
36 remote=$(get_default_remote)
37 remoteurl=$(git config "remote.$remote.url") ||
38 remoteurl=$(pwd) # the repository is its own authoritative upstream
40 remoteurl=${remoteurl%/}
49 remoteurl="${remoteurl%/*}"
52 remoteurl="${remoteurl%:*}"
56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
67 echo "$remoteurl$sep${url%/}"
71 # Get submodule info for registered submodules
72 # $@ = path to limit submodule list
76 git ls-files --error-unmatch --stage -- "$@" |
79 my ($null_sha1) = ("0" x 40);
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
97 # Map submodule path to submodule name
103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
108 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
115 # Prior to calling, cmd_update checks that a possibly existing
116 # path is not a git repository.
117 # Likewise, cmd_add checks that path does not exist at all,
118 # since it is the location of a new submodule.
126 if test -n "$GIT_QUIET"
133 name=$(module_name "$path")
134 base_path=$(dirname "$path")
136 gitdir=$(git rev-parse --git-dir)
137 gitdir_base="$gitdir/modules/$base_path"
138 gitdir="$gitdir/modules/$path"
142 a="$(cd_to_toplevel && pwd)/"
144 while [ "$b" ] && [ "${a%%/*}" = "${b%%/*}" ]
150 rel=`echo $rel | sed -e 's|[^/]*|..|g'`
154 rel=`echo $name | sed -e 's|[^/]*|..|g'`
155 rel_gitdir="$rel/$gitdir"
162 echo "gitdir: $rel_gitdir" >"$path/.git"
163 rm -f "$gitdir/index"
165 mkdir -p "$gitdir_base"
166 if test -n "$reference"
168 git-clone $quiet "$reference" -n "$url" "$path" --separate-git-dir "$gitdir"
170 git-clone $quiet -n "$url" "$path" --separate-git-dir "$gitdir"
172 die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
177 # Add a new submodule to the working tree, .gitmodules and the index
181 # optional branch is stored in global branch variable
185 # parse $args after "submodule ... add".
190 case "$2" in '') usage ;; esac
201 case "$2" in '') usage ;; esac
202 reference="--reference=$2"
226 if test -z "$path"; then
227 path=$(echo "$repo" |
228 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
231 if test -z "$repo" -o -z "$path"; then
235 # assure repo is absolute or relative to parent
238 # dereference source url relative to parent's url
239 realrepo=$(resolve_relative_url "$repo") || exit
246 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
251 # multiple //; leading ./; /./; /../; trailing /
252 path=$(printf '%s/\n' "$path" |
262 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
263 die "$(eval_gettext "'\$path' already exists in the index")"
265 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
267 eval_gettextln "The following path is ignored by one of your .gitignore files:
269 Use -f if you really want to add it." >&2
273 # perhaps the path exists and is already a git repo, else clone it
276 if test -d "$path"/.git -o -f "$path"/.git
278 eval_gettextln "Adding existing repo at '\$path' to the index"
280 die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
285 module_clone "$path" "$realrepo" "$reference" || exit
289 # ash fails to wordsplit ${branch:+-b "$branch"...}
291 '') git checkout -f -q ;;
292 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
294 ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
296 git config submodule."$path".url "$realrepo"
298 git add $force "$path" ||
299 die "$(eval_gettext "Failed to add submodule '\$path'")"
301 git config -f .gitmodules submodule."$path".path "$path" &&
302 git config -f .gitmodules submodule."$path".url "$repo" &&
303 git add --force .gitmodules ||
304 die "$(eval_gettext "Failed to register submodule '\$path'")"
308 # Execute an arbitrary command sequence in each checked out
311 # $@ = command to execute
315 # parse $args after "submodule ... foreach".
337 # dup stdin so that it can be restored when running the external
338 # command in the subshell (and a recursive call to this function)
342 while read mode sha1 stage path
344 if test -e "$path"/.git
346 say "$(eval_gettext "Entering '\$prefix\$path'")"
347 name=$(module_name "$path")
349 prefix="$prefix$path/"
353 if test -n "$recursive"
355 cmd_foreach "--recursive" "$@"
358 die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
364 # Register submodules in .git/config
366 # $@ = requested paths (default to all)
370 # parse $args after "submodule ... init".
392 while read mode sha1 stage path
394 # Skip already registered paths
395 name=$(module_name "$path") || exit
396 if test -z "$(git config "submodule.$name.url")"
398 url=$(git config -f .gitmodules submodule."$name".url)
400 die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
402 # Possibly a url relative to parent
405 url=$(resolve_relative_url "$url") || exit
408 git config submodule."$name".url "$url" ||
409 die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
412 # Copy "update" setting when it is not set yet
413 upd="$(git config -f .gitmodules submodule."$name".update)"
415 test -n "$(git config submodule."$name".update)" ||
416 git config submodule."$name".update "$upd" ||
417 die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
419 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
424 # Update each submodule path to correct revision, using clone and checkout as needed
426 # $@ = requested paths (default to all)
430 # parse $args after "submodule ... update".
451 case "$2" in '') usage ;; esac
452 reference="--reference=$2"
453 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
479 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
485 cmd_init "--" "$@" || return
491 while read mode sha1 stage path
495 echo >&2 "Skipping unmerged submodule $path"
498 name=$(module_name "$path") || exit
499 url=$(git config submodule."$name".url)
500 if ! test -z "$update"
502 update_module=$update
504 update_module=$(git config submodule."$name".update)
507 if test "$update_module" = "none"
509 echo "Skipping submodule '$path'"
515 # Only mention uninitialized submodules when its
516 # path have been specified
518 say "$(eval_gettext "Submodule path '\$path' not initialized
519 Maybe you want to use 'update --init'?")"
523 if ! test -d "$path"/.git -o -f "$path"/.git
525 module_clone "$path" "$url" "$reference"|| exit
526 cloned_modules="$cloned_modules;$name"
529 subsha1=$(clear_local_git_env; cd "$path" &&
530 git rev-parse --verify HEAD) ||
531 die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
534 if test "$subsha1" != "$sha1"
537 # If we don't already have a -f flag and the submodule has never been checked out
538 if test -z "$subsha1" -a -z "$force"
543 if test -z "$nofetch"
545 # Run fetch only if $sha1 isn't present or it
546 # is not reachable from a ref.
547 (clear_local_git_env; cd "$path" &&
548 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
549 test -z "$rev") || git-fetch)) ||
550 die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
553 # Is this something we just cloned?
554 case ";$cloned_modules;" in
556 # then there is no local change to integrate
561 case "$update_module" in
564 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
565 say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
566 must_die_on_failure=yes
570 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
571 say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
572 must_die_on_failure=yes
575 command="git checkout $subforce -q"
576 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
577 say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
581 if (clear_local_git_env; cd "$path" && $command "$sha1")
584 elif test -n "$must_die_on_failure"
586 die_with_status 2 "$die_msg"
588 err="${err};$die_msg"
593 if test -n "$recursive"
595 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
599 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$path'")"
602 err="${err};$die_msg"
605 die_with_status $res "$die_msg"
632 git describe "$2" 2>/dev/null ||
633 git describe --tags "$2" 2>/dev/null ||
634 git describe --contains "$2" 2>/dev/null ||
635 git describe --all --always "$2"
638 test -z "$revname" || revname=" ($revname)"
641 # Show commit summary for submodules in index or working tree
643 # If '--cached' is given, show summary between index and given commit,
644 # or between working tree and given commit
646 # $@ = [commit (default 'HEAD'),] requested paths (default all)
653 # parse $args after "submodule ... summary".
667 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
689 test $summary_limit = 0 && return
691 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
695 elif test -z "$1" -o "$1" = "HEAD"
697 # before the first commit: compare with an empty tree
698 head=$(git hash-object -w -t tree --stdin </dev/null)
699 test -z "$1" || shift
707 die "$(gettext -- "--cached cannot be used with --files")"
713 # Get modified modules cared by user
714 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
715 sane_egrep '^:([0-7]* )?160000' |
716 while read mod_src mod_dst sha1_src sha1_dst status name
718 # Always show modules deleted or type-changed (blob<->module)
719 test $status = D -o $status = T && echo "$name" && continue
720 # Also show added or modified modules which are checked out
721 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
726 test -z "$modules" && return
728 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
729 sane_egrep '^:([0-7]* )?160000' |
731 while read mod_src mod_dst sha1_src sha1_dst status name
733 if test -z "$cached" &&
734 test $sha1_dst = 0000000000000000000000000000000000000000
738 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
740 100644 | 100755 | 120000)
741 sha1_dst=$(git hash-object $name)
747 eval_gettextln "unexpected mode \$mod_dst" >&2
754 test $mod_src = 160000 &&
755 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
758 test $mod_dst = 160000 &&
759 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
763 case "$missing_src,$missing_dst" in
765 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
768 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
771 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
776 if test $mod_src = 160000 -a $mod_dst = 160000
778 range="$sha1_src...$sha1_dst"
779 elif test $mod_src = 160000
785 GIT_DIR="$name/.git" \
786 git rev-list --first-parent $range -- | wc -l
788 total_commits=" ($(($total_commits + 0)))"
792 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
793 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
796 blob="$(gettext "blob")"
797 submodule="$(gettext "submodule")"
798 if test $mod_dst = 160000
800 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
802 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
805 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
809 # Don't give error msg for modification whose dst is not submodule
810 # i.e. deleted or changed to blob
811 test $mod_dst = 160000 && echo "$errmsg"
813 if test $mod_src = 160000 -a $mod_dst = 160000
816 test $summary_limit -gt 0 && limit="-$summary_limit"
817 GIT_DIR="$name/.git" \
818 git log $limit --pretty='format: %m %s' \
819 --first-parent $sha1_src...$sha1_dst
820 elif test $mod_dst = 160000
822 GIT_DIR="$name/.git" \
823 git log --pretty='format: > %s' -1 $sha1_dst
825 GIT_DIR="$name/.git" \
826 git log --pretty='format: < %s' -1 $sha1_src
832 if test -n "$for_status"; then
833 if [ -n "$files" ]; then
834 gettextln "# Submodules changed but not updated:"
836 gettextln "# Submodule changes to be committed:"
839 sed -e 's|^|# |' -e 's|^# $|#|'
845 # List all submodules, prefixed with:
846 # - submodule not initialized
847 # + different revision checked out
849 # If --cached was specified the revision in the index will be printed
850 # instead of the currently checked out revision.
852 # $@ = requested paths (default to all)
856 # parse $args after "submodule ... status".
881 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
886 while read mode sha1 stage path
888 name=$(module_name "$path") || exit
889 url=$(git config submodule."$name".url)
890 displaypath="$prefix$path"
893 say "U$sha1 $displaypath"
896 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
898 say "-$sha1 $displaypath"
901 set_name_rev "$path" "$sha1"
902 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
904 say " $sha1 $displaypath$revname"
908 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
909 set_name_rev "$path" "$sha1"
911 say "+$sha1 $displaypath$revname"
914 if test -n "$recursive"
917 prefix="$displaypath/"
920 eval cmd_status "$orig_args"
922 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
927 # Sync remote urls for submodules
928 # This makes the value for remote.$remote.url match the value
929 # specified in .gitmodules.
954 while read mode sha1 stage path
956 name=$(module_name "$path")
957 url=$(git config -f .gitmodules --get submodule."$name".url)
959 # Possibly a url relative to parent
962 url=$(resolve_relative_url "$url") || exit
966 if git config "submodule.$name.url" >/dev/null 2>/dev/null
968 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
969 git config submodule."$name".url "$url"
971 if test -e "$path"/.git
976 remote=$(get_default_remote)
977 git config remote."$remote".url "$url"
984 # This loop parses the command line arguments to find the
985 # subcommand name to dispatch. Parsing of the subcommand specific
986 # options are primarily done by the subcommand implementations.
987 # Subcommand specific options such as --branch and --cached are
988 # parsed here as well, for backward compatibility.
990 while test $# != 0 && test -z "$command"
993 add | foreach | init | update | status | summary | sync)
1023 # No command word defaults to "status"
1024 test -n "$command" || command=status
1026 # "-b branch" is accepted only by "add"
1027 if test -n "$branch" && test "$command" != add
1032 # "--cached" is accepted only by "status" and "summary"
1033 if test -n "$cached" && test "$command" != status -a "$command" != summary